VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} dhMarkFrequentWords 
   Caption         =   "Ermitteln und markieren von Wortwiederholungen"
   ClientHeight    =   4005
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   6390
   OleObjectBlob   =   "dhMarkFrequentWords.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "dhMarkFrequentWords"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim oDoc As Document
Dim cColor1 As Long, farbe As String
Dim aFlag As Boolean, lu As Integer

Dim rng As Range
Dim myArray As Variant, dict As Object
Dim i As Long, v As Variant

Private Sub ListBox1_Click()
    TextBox2.text = ListBox1.List(ListBox1.ListIndex, 0)
End Sub

Private Sub UserForm_Initialize()
    Set oDoc = ActiveDocument
    anzW.Caption = ""
    anzG.Caption = ""
  
    With Me 'die UserForm an den rechten Rand des Wordfensters setzen
      .StartupPosition = 0
      .Top = Application.Top + (0.5 * Application.Height) - (0.5 * .Height)
      lu = Application.Left + Application.Width
      If lu + .Width > ScreenRect.Right - ScreenRect.Left Then  'Bildschirmrand berschritten
        .Left = lu - .Width
      Else
        .Left = lu
      End If
    End With
End Sub

Private Sub CommandButton1_Click()
    Set oDoc = ActiveDocument
    Set rng = selection.Range
    If rng = "" Then
        m = MsgBox("Es existiert keine Auswahl!", , "MELDUNG")
        Exit Sub
    End If
    ListBox1.Clear
    myArray = Split(rng.text, " ")
    QuickSort myArray, LBound(myArray), UBound(myArray)
'    debugArray (woerter)
    Set dict = CreateObject("Scripting.Dictionary")
    For i = LBound(myArray) To UBound(myArray)
        If dict.Exists(myArray(i)) Then
            dict.item(myArray(i)) = dict.item(myArray(i)) + 1
        Else
            dict.Add myArray(i), 1
        End If
    Next i
    'die Listbox fllen mit den Wrtern der Auswahl
    i = 0
    For Each v In dict.Keys
        If dict.item(v) >= Val(TextBox1.text) Then  'Vergleich mit Obergrenze Wortanzahl
            With ListBox1
                .AddItem
                .List(i, 0) = v
                .List(i, 1) = dict.item(v)
            End With
            i = i + 1
        End If
    Next v
    anzG.Caption = Format(i, "#,##0")
End Sub

Private Sub color_Click()
' Colordialog aufrufen zum ndern der Markierungsfarbe
    farbe = ShowColorDialog.ShowColorDialog
    If farbe <> "" Then
        color.BackColor = farbe
        cColor1 = farbe
    End If
End Sub

Private Sub CommandButton4_Click()
    If TextBox2.text = "" Then Exit Sub 'kein Wort eingegeben
    Dim oRng As Range
    Set oRng = selection.Range  'Range einer Auswahl
    If oRng = "" Then
        aFlag = False
        Set oRng = oDoc.Range 'wenn keine Auswahl, dann gesamtes Dokument
    Else
        aFlag = True
    End If
    i = 0
    SelectionFind oRng, TextBox2.text, color.BackColor  'finden und farblich markieren
End Sub

Private Sub CommandButton5_Click()
    Unload Me
End Sub

Private Sub CommandButton6_Click()
    myEditUndo  'rckgngig aller Makro-Aktionen
End Sub

'Finden aller Wrter und mit ausgewhlter Farbe markieren,
'die mit Eingabe-Wort bereinstimmen
'rng:       Range, entweder Auswahl oder Dokument
'strFind:   das Wort, dessen Wiederholunen gefunden werden sollen
'col:       die Farbe, mit der die gefundenen Wrter hinterlegt werden
Sub SelectionFind(rng As Range, strFind As String, col As Long)
    a = rng.Start
    e = rng.End
    StartUndoSaver
    With rng.Find
         Do
            .ClearFormatting
            .text = strFind
            .Forward = True
            .Wrap = wdFindAsk
            .Format = False
            .MatchCase = CheckBox1.Value
            .MatchWholeWord = CheckBox2.Value
            If .Execute = True Then
'                MsgBox ("Text gefunden.")
                rng.Select
                If selection.Start > e Then
                    Exit Do
                End If
                'frben des Worthintergrunds
                selection.Shading.ForegroundPatternColor = wdColorAutomatic
                selection.Shading.BackgroundPatternColor = col
                i = i + 1   'Wortzhler
            Else
'                MsgBox ("Text nicht gefunden.")
                Exit Do
            End If
        Loop
    End With
    anzW.Caption = Format(i, "#,##0")
    If aFlag Then
    'die ursprngliche Auswahl wieder herstellen
        With rng
            .Start = a
            .End = e
            .Select
        End With
    End If
    EndUndoSaver
End Sub

