Attribute VB_Name = "showColordialog"
'static array to contain the custom colours selected by the user
Private dwCustClrs(0 To 15) As Long

'ChooseColor structure flag constants
Private Const CC_RGBINIT         As Long = &H1
Private Const CC_FULLOPEN        As Long = &H2
Private Const CC_PREVENTFULLOPEN As Long = &H4
Private Const CC_ENABLEHOOK      As Long = &H10
Private Const CC_SOLIDCOLOR      As Long = &H80
Private Const CC_ANYCOLOR        As Long = &H100

Private Type CHOOSECOLORSTRUCT
   lStructSize     As Long
   hwndOwner       As Long
   hInstance       As Long
   rgbResult       As Long
   lpCustColors    As Long
   flags           As Long
   lCustData       As Long
   lpfnHook        As Long
   lpTemplateName  As String
End Type

Private Declare Function ChooseColor Lib "comdlg32.dll" _
   Alias "ChooseColorA" (lpcc As CHOOSECOLORSTRUCT) As Long

Private Declare Function FindWindow Lib "user32" _
    Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Dim hWnd As Long
Dim x, y, cx, cy As Integer
Dim hexColor As String

Private Sub iniCustom()
    Dim cnt As Long
    'populate the custom colours with a series of gray shades
    For cnt = 240 To 15 Step -15
        dwCustClrs((cnt \ 15) - 1) = RGB(cnt, cnt, cnt)
    Next
'    thePosition = stdPositions.RightTop
    newRect.Left = 200
    newRect.Top = 400
End Sub

Private Function GetWinwordHwnd() As Long
    hWnd = FindWindow("opusApp", vbNullString)
    GetWinwordHwnd = hWnd
End Function

Public Function ShowColorDialog()
    Dim cc As CHOOSECOLORSTRUCT
    Dim lReturn, Rval, Gval, Bval As Long
    Dim i As Integer
    iniCustom
    With cc
        .lStructSize = Len(cc)
        .hwndOwner = GetWinwordHwnd()
        .hInstance = 0
        .lpCustColors = VarPtr(dwCustClrs(0))
        ' Erscheinungsbild des Dialogs vorgeben
        .flags = CC_ENABLEHOOK Or CC_ANYCOLOR Or CC_RGBINIT 'Or CC_FULLOPEN
        .lpfnHook = FARPROC(AddressOf ChooseColorProc)
    End With
    
   ' call the color picker
    lReturn = ChooseColor(cc)
    If lReturn <> 0 Then
        ' extract the color values
        Rval = cc.rgbResult Mod 256
        Bval = Int(cc.rgbResult / 65536)
        Gval = Int((cc.rgbResult - (Bval * 65536) - Rval) / 256)
        hexColor = "&H" & Hex(RGB(Rval, Gval, Bval))
        
'        Debug.Print ("RGB:" & str(Rval) & "," & str(Gval) & "," & str(Bval))
'        Debug.Print "Hex: " & hexColor
    Else
        hexColor = ""
    End If
    ShowColorDialog = hexColor
End Function


